/************************************************************************************/
/*  Program name CAPPOEXT_PURCHASE_ORDER_LINE.sql                                   */
/*  Creater:  Kenny, Leung (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 16 Jan 2006, Kenny Leung         First created                               */
/************************************************************************************/

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;s
alter session set nls_date_format='YYYYMMDD HH24:MI:SS';

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPPOEXT_PURCHASE_ORDER_LINE';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPPO_PURCHASE_ORDER_LINE.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		PHA.*
	FROM
		PO_LINES_ALL		PHA,
		HR_ALL_ORGANIZATION_UNITS	HRO
	WHERE	PHA.ORG_ID	=	HRO.ORGANIZATION_ID
	AND		SUBSTR(HRO.NAME,4,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	SUBSTR(UPPER('&1'), -4);

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
        
        lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
        
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				    C1.PO_LINE_ID                   ||CHR(9)|| 
                      C1.LAST_UPDATE_DATE             ||CHR(9)|| 
                      C1.LAST_UPDATED_BY              ||CHR(9)|| 
                      C1.PO_HEADER_ID                 ||CHR(9)|| 
                      C1.LINE_TYPE_ID                 ||CHR(9)|| 
                      C1.LINE_NUM                     ||CHR(9)|| 
                      C1.LAST_UPDATE_LOGIN            ||CHR(9)|| 
                      C1.CREATION_DATE                ||CHR(9)|| 
                      C1.CREATED_BY                   ||CHR(9)|| 
                      C1.ITEM_ID                      ||CHR(9)|| 
                      C1.ITEM_REVISION                ||CHR(9)|| 
                      C1.CATEGORY_ID                  ||CHR(9)|| 
                      C1.ITEM_DESCRIPTION             ||CHR(9)|| 
                      C1.UNIT_MEAS_LOOKUP_CODE        ||CHR(9)|| 
                      C1.QUANTITY_COMMITTED           ||CHR(9)|| 
                      C1.COMMITTED_AMOUNT             ||CHR(9)|| 
                      C1.ALLOW_PRICE_OVERRIDE_FLAG    ||CHR(9)|| 
                      C1.NOT_TO_EXCEED_PRICE          ||CHR(9)|| 
                      C1.LIST_PRICE_PER_UNIT          ||CHR(9)|| 
                      C1.UNIT_PRICE                   ||CHR(9)|| 
                      C1.QUANTITY                     ||CHR(9)|| 
                      C1.UN_NUMBER_ID                 ||CHR(9)|| 
                      C1.HAZARD_CLASS_ID              ||CHR(9)|| 
                      C1.NOTE_TO_VENDOR               ||CHR(9)|| 
                      C1.FROM_HEADER_ID               ||CHR(9)|| 
                      C1.FROM_LINE_ID                 ||CHR(9)|| 
                      C1.MIN_ORDER_QUANTITY           ||CHR(9)|| 
                      C1.MAX_ORDER_QUANTITY           ||CHR(9)|| 
                      C1.QTY_RCV_TOLERANCE            ||CHR(9)|| 
                      C1.OVER_TOLERANCE_ERROR_FLAG    ||CHR(9)|| 
                      C1.MARKET_PRICE                 ||CHR(9)|| 
                      C1.UNORDERED_FLAG               ||CHR(9)|| 
                      C1.CLOSED_FLAG                  ||CHR(9)|| 
                      C1.USER_HOLD_FLAG               ||CHR(9)|| 
                      C1.CANCEL_FLAG                  ||CHR(9)|| 
                      C1.CANCELLED_BY                 ||CHR(9)|| 
                      C1.CANCEL_DATE                  ||CHR(9)|| 
                      C1.CANCEL_REASON                ||CHR(9)|| 
                      C1.FIRM_STATUS_LOOKUP_CODE      ||CHR(9)|| 
                      C1.FIRM_DATE                    ||CHR(9)|| 
                      C1.VENDOR_PRODUCT_NUM           ||CHR(9)|| 
                      C1.CONTRACT_NUM                 ||CHR(9)|| 
                      C1.TAXABLE_FLAG                 ||CHR(9)|| 
                      C1.TAX_NAME                     ||CHR(9)|| 
                      C1.TYPE_1099                    ||CHR(9)|| 
                      C1.CAPITAL_EXPENSE_FLAG         ||CHR(9)|| 
                      C1.NEGOTIATED_BY_PREPARER_FLAG  ||CHR(9)|| 
                      C1.ATTRIBUTE_CATEGORY           ||CHR(9)|| 
                      C1.ATTRIBUTE1                   ||CHR(9)|| 
                      C1.ATTRIBUTE2                   ||CHR(9)|| 
                      C1.ATTRIBUTE3                   ||CHR(9)|| 
                      C1.ATTRIBUTE4                   ||CHR(9)|| 
                      C1.ATTRIBUTE5                   ||CHR(9)|| 
                      C1.ATTRIBUTE6                   ||CHR(9)|| 
                      C1.ATTRIBUTE7                   ||CHR(9)|| 
                      C1.ATTRIBUTE8                   ||CHR(9)|| 
                      C1.ATTRIBUTE9                   ||CHR(9)|| 
                      C1.ATTRIBUTE10                  ||CHR(9)|| 
                      C1.REFERENCE_NUM                ||CHR(9)|| 
                      C1.ATTRIBUTE11                  ||CHR(9)|| 
                      C1.ATTRIBUTE12                  ||CHR(9)|| 
                      C1.ATTRIBUTE13                  ||CHR(9)|| 
                      C1.ATTRIBUTE14                  ||CHR(9)|| 
                      C1.ATTRIBUTE15                  ||CHR(9)|| 
                      C1.MIN_RELEASE_AMOUNT           ||CHR(9)|| 
                      C1.PRICE_TYPE_LOOKUP_CODE       ||CHR(9)|| 
                      C1.CLOSED_CODE                  ||CHR(9)|| 
                      C1.PRICE_BREAK_LOOKUP_CODE      ||CHR(9)|| 
                      C1.USSGL_TRANSACTION_CODE       ||CHR(9)|| 
                      C1.GOVERNMENT_CONTEXT           ||CHR(9)|| 
                      C1.REQUEST_ID                   ||CHR(9)|| 
                      C1.PROGRAM_APPLICATION_ID       ||CHR(9)|| 
                      C1.PROGRAM_ID                   ||CHR(9)|| 
                      C1.PROGRAM_UPDATE_DATE          ||CHR(9)|| 
                      C1.CLOSED_DATE                  ||CHR(9)|| 
                      C1.CLOSED_REASON                ||CHR(9)|| 
                      C1.CLOSED_BY                    ||CHR(9)|| 
                      C1.TRANSACTION_REASON_CODE      ||CHR(9)|| 
                      C1.ORG_ID                       ||CHR(9)|| 
                      C1.QC_GRADE                     ||CHR(9)|| 
                      C1.BASE_UOM                     ||CHR(9)|| 
                      C1.BASE_QTY                     ||CHR(9)|| 
                      C1.SECONDARY_UOM                ||CHR(9)|| 
                      C1.SECONDARY_QTY                ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE_CATEGORY    ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE1            ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE2            ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE3            ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE4            ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE5            ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE6            ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE7            ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE8            ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE9            ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE10           ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE11           ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE12           ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE13           ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE14           ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE15           ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE16           ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE17           ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE18           ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE19           ||CHR(9)|| 
                      C1.GLOBAL_ATTRIBUTE20           ||CHR(9)|| 
                      C1.LINE_REFERENCE_NUM           ||CHR(9)|| 
                      C1.PROJECT_ID                   ||CHR(9)|| 
                      C1.TASK_ID                      ||CHR(9)|| 
                      C1.EXPIRATION_DATE              ||CHR(9)|| 
                      C1.TAX_CODE_ID                  ||CHR(9)|| 
                      C1.OKE_CONTRACT_HEADER_ID       ||CHR(9)|| 
                      C1.OKE_CONTRACT_VERSION_ID      ||CHR(9)|| 
                      C1.SECONDARY_QUANTITY           ||CHR(9)|| 
                      C1.SECONDARY_UNIT_OF_MEASURE    ||CHR(9)|| 
                      C1.PREFERRED_GRADE              ||CHR(9)|| 
                      C1.AUCTION_HEADER_ID            ||CHR(9)|| 
                      C1.AUCTION_DISPLAY_NUMBER       ||CHR(9)|| 
                      C1.AUCTION_LINE_NUMBER          ||CHR(9)|| 
                      C1.BID_NUMBER                   ||CHR(9)|| 
                      C1.BID_LINE_NUMBER              ||CHR(9)|| 
                      C1.RETROACTIVE_DATE             
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No PO Lines for NGO';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/

